#!/usr/bin/perl
#------------------------------------------------------------------------------
#    FileList v1.0 - lists all files within a directory
#    Copyright (c) 2001 Arne "Heinz99" Bochem <webmaster@heinz99.de>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#------------------------------------------------------------------------------
#    INSTALL
#
#    1. Change the variables in the script head.
#    2. Change the two template .html files.
#    3. Rename them, if you changed their names in the variables.
#    4. Upload the files and install as you would do with any other CGIish Perl
#       Script
#------------------------------------------------------------------------------

use strict;

#------------------------------------------------------------------------------
#    Change these variables:

#    This is the filename of the upper HTML code template.
my $htmlhead   = 'htmlhead.html';

#    This is the filename of the lower HTML code template.
my $htmlfoot   = 'htmlfoot.html';

#    This is the server internal path to the directory you want to list.
#    [Include trailing slash.]
my $serverpath = '../publicfiles/';

#    This is the webserver path to the directory you want to list.
#    Often the same es the server internal path. Sometimes you will want to
#    define it yourself, so I put this option here.
#    For example: /publicfiles/
#    [Include trailing slash.]
my $publicpath = $serverpath;

#------------------------------------------------------------------------------
#    Here begins the real code. No need to change anything, unless you want to
#    meddle with my gracious code. ;]

#    Output HTTP header
print 'Content-Type: text/html'."\n\n";

#    Upper HTML part
open(HEADER, $htmlhead);
print join('', <HEADER>);
close(HEADER);

#    The list itself
$, = "\n";
my $serverpathQuoted = quotemeta($serverpath);
print '<ul>',
      (map
      {
        s/^$serverpathQuoted//g;
        '<li><a href="'.$publicpath.$_.'">'.$_.'</a></li>';
      } glob($serverpath."*")),
			'</ul>';

#    Lower HTML part
open(FOOTER, $htmlfoot);
print join('', <FOOTER>);
close(FOOTER);
